/// <reference types="react" />
import type { Client, ClientConfig, ClientGlobals } from '@searchspring/snap-client';
import type { AbstractController, SearchControllerConfig, AutocompleteControllerConfig, FinderControllerConfig, RecommendationControllerConfig, ContextVariables } from '@searchspring/snap-controller';
import type { AbstractStore } from '@searchspring/snap-store-mobx';
import type { UrlManager, UrlTranslatorConfig } from '@searchspring/snap-url-manager';
import type { EventManager } from '@searchspring/snap-event-manager';
import type { Profiler } from '@searchspring/snap-profiler';
import type { Logger } from '@searchspring/snap-logger';
import type { Tracker } from '@searchspring/snap-tracker';
export declare type SnapControllerServices = {
    client?: Client;
    store?: AbstractStore;
    urlManager?: UrlManager;
    eventManager?: EventManager;
    profiler?: Profiler;
    logger?: Logger;
    tracker?: Tracker;
};
export declare type SnapControllerConfigs = SnapSearchControllerConfig | SnapAutocompleteControllerConfig | SnapFinderControllerConfig | SnapRecommendationControllerConfig;
export declare type RootComponent = React.ElementType<{
    controller: AbstractController;
}>;
export declare type SnapSearchControllerConfig = {
    url?: UrlTranslatorConfig;
    client?: {
        globals: ClientGlobals;
        config?: ClientConfig;
    };
    controller: SearchControllerConfig;
    context?: ContextVariables;
};
export declare type SnapAutocompleteControllerConfig = {
    url?: UrlTranslatorConfig;
    client?: {
        globals: ClientGlobals;
        config?: ClientConfig;
    };
    controller: AutocompleteControllerConfig;
    context?: ContextVariables;
};
export declare type SnapFinderControllerConfig = {
    url?: UrlTranslatorConfig;
    client?: {
        globals: ClientGlobals;
        config?: ClientConfig;
    };
    controller: FinderControllerConfig;
    context?: ContextVariables;
};
export declare type SnapRecommendationControllerConfig = {
    url?: UrlTranslatorConfig;
    client?: {
        globals: ClientGlobals;
        config?: ClientConfig;
    };
    controller: RecommendationControllerConfig;
    context?: ContextVariables;
};
//# sourceMappingURL=types.d.ts.map